//****************************************************************************
// Copyright (C) 2001,2002,2003,2004  PEAK System-Technik GmbH
//
// linux@peak-system.com
// www.peak-system.com
//
// This part of software is proprietary 
// No warranty is given at all
//
// Maintainer(s): Klaus Hitschler (klaus.hitschler@gmx.de)
//****************************************************************************

//****************************************************************************
//
// pcan_usb-kernel.c - the inner hidden usb parts for pcan-usb support
//
// $Log: pcan_usb_kernel.c,v $
// Revision 1.19  2004/10/24 21:17:33  klaus
// release_20041024, timeout in urb_t removed up from kernel 2.6.9
//
// Revision 1.18  2004/09/14 17:57:40  klaus
// Released release_20040915_x
//
// Revision 1.17  2004/09/14 17:51:10  klaus
// Take real names for pcan_hw_X and pcan_hw_Y
//
// Revision 1.16  2004/07/18 14:15:54  klaus
// removed 'scheduling while atomic!', accept or transmitt DLC while ignoring data content when RTR data
//
// Revision 1.15  2004/05/13 15:32:58  klaus
// devfs is depreciated, moved handling from Makefile to pcan_common.h
//
// Revision 1.14  2004/05/06 18:48:10  klaus
// Improvements triggered by Mandrake distribution 2.6.3-7mdk: MODULE_VERSION macro
//
// Revision 1.13  2004/05/02 15:56:52  klaus
// Last corrections and improvements, especially for Makefile(s) and build scenarios
//
// Revision 1.12  2004/05/02 12:06:02  klaus
// total rebuild of Makefile for KBUILD support for Kernel 2.6
//
// Revision 1.11  2004/04/13 20:33:36  klaus
// FASTSCALE is faster with nearly the same accuracy, use FASTSCALE. obfuscation done.
//
// Revision 1.10  2004/04/13 20:33:35  klaus
// FASTSCALE is faster with nearly the same accuracy, use FASTSCALE. obfuscation done.
//
// Revision 1.9  2004/04/11 22:03:29  klaus
// cosmetic changes
//
// Revision 1.8  2004/04/10 12:25:39  klaus
// merge polished between HEAD and kernel-2.6 branch
//
// Revision 1.7.2.2  2004/04/09 22:56:09  klaus
// parts are usable for kernel 2.2-2.6, last step before join with HEAD
//
// Revision 1.7.2.1  2004/04/09 22:56:09  klaus
// parts are usable for kernel 2.2-2.6, last step before join with HEAD
//
// Revision 1.7  2004/03/04 19:43:55  klaus
// wrong handling of RTR data contents - really -removed
//
// Revision 1.6  2004/03/04 18:50:41  klaus
// wrong handling of RTR data contents removed
//
// Revision 1.5  2003/03/02 12:18:33  klaus
// Release_20030302_?
//
// Revision 1.4  2003/03/02 12:18:33  klaus
// Release_20030302_?
//
// Revision 1.3  2003/03/02 11:09:21  klaus
// removed software distribution limitation in header
//
// Revision 1.2  2003/03/02 10:46:31  klaus
// merged USB thread into main path
//
// Revision 1.1.2.34  2003/02/24 19:13:01  klaus
// another try with obfuscation
//
// Revision 1.1.2.33  2003/02/24 18:39:16  klaus
// removed Makefile inconsistency
//
// Revision 1.1.2.32  2003/02/23 19:32:10  klaus
// fixed system macro strangeness in cobf processing
//
// Revision 1.1.2.31  2003/02/22 18:19:24  klaus
// small changes
//
// Revision 1.1.2.29  2003/02/22 18:00:08  klaus
// pcan_usb_kernel.c inherits its header from predecessor
//
//****************************************************************************

/* COBF by BB -- obfuscated at Sun Oct 24 23:15:42 2004
*/
#include<src/pcan_common.h>
#include<pcan.h>
#include<src/pcan_fifo.h>
#include<src/pcan_usb_kernel.h>
#include"cobf.h"
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
#define pcan_l97 1000
#endif
pcan_l91 pcan_l170{pcan_c pcan_i[4];pcan_l44 pcan_l41;}pcan_l116;
pcan_l91 pcan_l170{pcan_c pcan_i[2];pcan_l43 pcan_l95;}pcan_l153;
pcan_l91 pcan_n{pcan_c pcan_l60;pcan_c pcan_l58;pcan_c pcan_l128;
pcan_c pcan_l127;pcan_c pcan_l102;pcan_c pcan_l125;pcan_c pcan_l101;
pcan_c pcan_l103;pcan_c pcan_l123;pcan_c pcan_l120;pcan_c pcan_l169;
pcan_c pcan_l168;pcan_c pcan_l139;pcan_c pcan_l138;pcan_c pcan_l137;
pcan_c pcan_l136;}__attribute__((packed))pcan_l90;pcan_l91 pcan_n{
pcan_l105 pcan_l30;pcan_l105 pcan_l69;pcan_l44 pcan_l62;pcan_l43
pcan_l89;pcan_l43 pcan_l40;pcan_l43 pcan_l67;pcan_c pcan_l71;}
pcan_l34;pcan_l29 pcan_l48 pcan_l141(pcan_n pcan_p*pcan_b){pcan_l34*
pcan_h=(pcan_l34* )pcan_b->pcan_m.pcan_l.pcan_l75;pcan_s(pcan_v"\x25"
"\x73\x3a\x20\x72\x65\x73\x65\x74\x5f\x74\x69\x6d\x65\x73\x74\x61\x6d"
"\x70\x28\x29\n",pcan_o);pcan_h->pcan_l30=0;pcan_h->pcan_l69=0;pcan_h
->pcan_l40=0;pcan_h->pcan_l71=0;pcan_h->pcan_l67=0;pcan_h->pcan_l62=0
;pcan_h->pcan_l89=0;}pcan_l29 pcan_l144 pcan_l44 pcan_l150(pcan_n
pcan_p*pcan_b){pcan_l50 pcan_l34*pcan_h=(pcan_l34* )pcan_b->pcan_m.
pcan_l.pcan_l75;pcan_l105 pcan_l94;pcan_l94=pcan_h->pcan_l30-pcan_h->
pcan_l89;pcan_l94*=44739;pcan_q(pcan_l44)(pcan_l94>>=20);}pcan_l29
pcan_l144 pcan_l44 pcan_l126(pcan_n pcan_p*pcan_b){pcan_q((pcan_l34* )pcan_b
->pcan_m.pcan_l.pcan_l75)->pcan_l62+pcan_l150(pcan_b);}pcan_l29
pcan_l48 pcan_l83(pcan_n pcan_p*pcan_b,pcan_l43 pcan_r,pcan_c
pcan_l171){pcan_l50 pcan_l34*pcan_h=(pcan_l34* )pcan_b->pcan_m.pcan_l
.pcan_l75;pcan_e(!pcan_h->pcan_l62){pcan_h->pcan_l62=pcan_l197()- *
pcan_b->pcan_l207;pcan_h->pcan_l89=pcan_r;pcan_h->pcan_l67=pcan_r;
pcan_h->pcan_l30=pcan_r;pcan_h->pcan_l69=pcan_r;}pcan_e(pcan_l171){
pcan_h->pcan_l30=pcan_h->pcan_l69;pcan_h->pcan_l40=pcan_h->pcan_l67;}
pcan_h->pcan_l69=pcan_h->pcan_l30;pcan_h->pcan_l67=pcan_h->pcan_l40;
pcan_e(pcan_r<pcan_h->pcan_l40)pcan_h->pcan_l30+=0x10000LL;pcan_h->
pcan_l30&=~0xFFFFLL;pcan_h->pcan_l30|=pcan_r;pcan_h->pcan_l40=pcan_r;
pcan_h->pcan_l71=(pcan_c)(pcan_r&0xff);}pcan_l29 pcan_l48 pcan_l104(
pcan_n pcan_p*pcan_b,pcan_c pcan_l63){pcan_l50 pcan_l34*pcan_h=(
pcan_l34* )pcan_b->pcan_m.pcan_l.pcan_l75;pcan_e(pcan_l63<pcan_h->
pcan_l71){pcan_h->pcan_l30+=0x100;pcan_h->pcan_l40+=0x100;}pcan_h->
pcan_l30&=~0xFFLL;pcan_h->pcan_l30|=pcan_l63;pcan_h->pcan_l40&=~0xFF;
pcan_h->pcan_l40|=pcan_l63;pcan_h->pcan_l71=pcan_l63;}pcan_f pcan_X(
pcan_l48){pcan_q pcan_l66(pcan_l34);}pcan_l29 pcan_l48 pcan_l88(
pcan_l92 pcan_l156){pcan_n pcan_p*pcan_b=pcan_l156->pcan_l188;
pcan_l206(1,&pcan_b->pcan_m.pcan_l.pcan_l79);pcan_l84(&pcan_b->pcan_m
.pcan_l.pcan_l45,1);}pcan_l29 pcan_f pcan_l36(pcan_n pcan_p*pcan_b,
pcan_c pcan_l49,pcan_c pcan_l46,pcan_c pcan_l31,pcan_c pcan_l39,
pcan_c pcan_l81,pcan_c pcan_l80,pcan_c pcan_l78,pcan_c pcan_l77,
pcan_c pcan_l100,pcan_c pcan_l76,pcan_c pcan_l135,pcan_c pcan_l134,
pcan_c pcan_l167,pcan_c pcan_l162,pcan_c pcan_l166,pcan_c pcan_l165){
pcan_l90 pcan_j;pcan_f pcan_l27=0;pcan_l50 pcan_l92 pcan_u;pcan_e(!
pcan_b->pcan_l151)pcan_q-pcan_l163;pcan_j.pcan_l60=pcan_l49;pcan_j.
pcan_l58=pcan_l46;pcan_j.pcan_l128=pcan_l31;pcan_j.pcan_l127=pcan_l39
;pcan_j.pcan_l102=pcan_l81;pcan_j.pcan_l125=pcan_l80;pcan_j.pcan_l101
=pcan_l78;pcan_j.pcan_l103=pcan_l77;pcan_j.pcan_l123=pcan_l100;pcan_j
.pcan_l120=pcan_l76;pcan_j.pcan_l169=pcan_l135;pcan_j.pcan_l168=
pcan_l134;pcan_j.pcan_l139=pcan_l167;pcan_j.pcan_l138=pcan_l162;
pcan_j.pcan_l137=pcan_l166;pcan_j.pcan_l136=pcan_l165;pcan_u=pcan_b->
pcan_m.pcan_l.pcan_l131;pcan_l111(pcan_u,pcan_b->pcan_m.pcan_l.
pcan_l56,pcan_l146(pcan_b->pcan_m.pcan_l.pcan_l56,pcan_b->pcan_m.
pcan_l.pcan_l110[1].pcan_l28),&pcan_j,pcan_l66(pcan_j),pcan_l88,
pcan_b);
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
pcan_u->pcan_l130=((pcan_l97*pcan_l108)/1000);
#endif
pcan_e(pcan_l114(pcan_u)){pcan_s(pcan_l59"\x25\x73\x3a\x20\x70\x63"
"\x61\x6e\x5f\x73\x65\x74\x5f\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x28"
"\x29\x20\x63\x61\x6e\x27\x74\x20\x73\x75\x62\x6d\x69\x74\x21\n",
pcan_o);pcan_l27=pcan_u->pcan_l47;pcan_l35 pcan_l26;}pcan_z pcan_l109
(1,&pcan_b->pcan_m.pcan_l.pcan_l79);pcan_l38(!pcan_l118(&pcan_b->
pcan_m.pcan_l.pcan_l45))pcan_l106();pcan_l27=pcan_u->pcan_l47;
pcan_l26:pcan_l84(&pcan_b->pcan_m.pcan_l.pcan_l45,0);pcan_q pcan_l27;
}pcan_l29 pcan_f pcan_l155(pcan_n pcan_p*pcan_b,pcan_c pcan_l49,
pcan_c pcan_l46){pcan_l90 pcan_j;pcan_f pcan_l27=0;pcan_l50 pcan_l92
pcan_u;pcan_j.pcan_l60=pcan_l49;pcan_j.pcan_l58=pcan_l46;pcan_u=
pcan_b->pcan_m.pcan_l.pcan_l131;pcan_l111(pcan_u,pcan_b->pcan_m.
pcan_l.pcan_l56,pcan_l146(pcan_b->pcan_m.pcan_l.pcan_l56,pcan_b->
pcan_m.pcan_l.pcan_l110[1].pcan_l28),&pcan_j,pcan_l66(pcan_j.pcan_l60
)+pcan_l66(pcan_j.pcan_l58),pcan_l88,pcan_b);
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
pcan_u->pcan_l130=((pcan_l97*pcan_l108)/1000);
#endif
pcan_e(pcan_l114(pcan_u)){pcan_l98(pcan_l59"\x25\x73\x3a\x20\x70\x63"
"\x61\x6e\x5f\x73\x65\x74\x5f\x66\x75\x6e\x63\x74\x69\x6f\x6e\x28\x29"
"\x20\x63\x61\x6e\x27\x74\x20\x73\x75\x62\x6d\x69\x74\x21\n",pcan_o);
pcan_l27=pcan_u->pcan_l47;pcan_l35 pcan_l26;}pcan_z pcan_l109(1,&
pcan_b->pcan_m.pcan_l.pcan_l79);pcan_l38(!pcan_l118(&pcan_b->pcan_m.
pcan_l.pcan_l45))pcan_l106();pcan_l27=pcan_u->pcan_l47;pcan_l26:
pcan_l84(&pcan_b->pcan_m.pcan_l.pcan_l45,0);pcan_q pcan_l27;}pcan_l29
pcan_f pcan_l55(pcan_n pcan_p*pcan_b,pcan_c pcan_l49,pcan_c pcan_l46,
pcan_c*pcan_l31,pcan_c*pcan_l39,pcan_c*pcan_l81,pcan_c*pcan_l80,
pcan_c*pcan_l78,pcan_c*pcan_l77,pcan_c*pcan_l100,pcan_c*pcan_l76){
pcan_l90 pcan_j;pcan_f pcan_l27=0;pcan_l50 pcan_l92 pcan_u;pcan_e(!
pcan_b->pcan_l151)pcan_q-pcan_l163;pcan_l27=pcan_l155(pcan_b,pcan_l49
,pcan_l46);pcan_l175(5);pcan_e(!pcan_l27){pcan_u=pcan_b->pcan_m.
pcan_l.pcan_l131;pcan_l111(pcan_u,pcan_b->pcan_m.pcan_l.pcan_l56,
pcan_l193(pcan_b->pcan_m.pcan_l.pcan_l56,pcan_b->pcan_m.pcan_l.
pcan_l110[0].pcan_l28),&pcan_j,pcan_l66(pcan_j),pcan_l88,pcan_b);
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,9)
pcan_u->pcan_l130=((pcan_l97*pcan_l108)/1000);
#endif
pcan_j.pcan_l60=pcan_l49;pcan_j.pcan_l58=pcan_l46;pcan_e(pcan_l114(
pcan_u)){pcan_l98(pcan_l59"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x67"
"\x65\x74\x5f\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x28\x29\x20\x63\x61"
"\x6e\x27\x74\x20\x73\x75\x62\x6d\x69\x74\x21\n",pcan_o);pcan_l27=
pcan_u->pcan_l47;pcan_l35 pcan_l26;}pcan_z pcan_l109(1,&pcan_b->
pcan_m.pcan_l.pcan_l79);pcan_l38(!pcan_l118(&pcan_b->pcan_m.pcan_l.
pcan_l45))pcan_l106();pcan_e(!pcan_u->pcan_l47){ *pcan_l31=pcan_j.
pcan_l128; *pcan_l39=pcan_j.pcan_l127; *pcan_l81=pcan_j.pcan_l102; *
pcan_l80=pcan_j.pcan_l125; *pcan_l78=pcan_j.pcan_l101; *pcan_l77=
pcan_j.pcan_l103; *pcan_l100=pcan_j.pcan_l123; *pcan_l76=pcan_j.
pcan_l120;}pcan_l27=pcan_u->pcan_l47;}pcan_l26:pcan_l84(&pcan_b->
pcan_m.pcan_l.pcan_l45,0);pcan_q pcan_l27;}pcan_l29 pcan_f pcan_l148(
pcan_n pcan_p*pcan_b,pcan_l43 pcan_l99){pcan_c pcan_a=0;pcan_c
pcan_l31=(pcan_c)(pcan_l99&0xff);pcan_c pcan_l39=(pcan_c)((pcan_l99>>
8)&0xff);pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77"
"\x5f\x73\x65\x74\x42\x54\x52\x30\x42\x54\x52\x31\x28\x30\x78\x25\x30"
"\x34\x78\x29\n",pcan_o,pcan_l99);pcan_q pcan_l36(pcan_b,1,2,pcan_l31
,pcan_l39,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a);}pcan_f pcan_hw_SetCANOn(pcan_n pcan_p*
pcan_b){pcan_c pcan_a=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61"
"\x6e\x5f\x68\x77\x5f\x53\x65\x74\x43\x41\x4e\x4f\x6e\x28\x29\n",
pcan_o);pcan_q pcan_l36(pcan_b,3,2,1,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_f pcan_hw_SetCANOff(pcan_n pcan_p*pcan_b){pcan_f pcan_g;pcan_c
pcan_a=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77"
"\x5f\x53\x65\x74\x43\x41\x4e\x4f\x66\x66\x28\x29\n",pcan_o);pcan_g=
pcan_l36(pcan_b,3,2,0,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);pcan_q pcan_g;}
pcan_l29 pcan_f pcan_l160(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;
pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53"
"\x65\x74\x43\x41\x4e\x53\x69\x6c\x65\x6e\x74\x4f\x6e\x28\x29\n",
pcan_o);pcan_q pcan_l36(pcan_b,3,3,1,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_l29 pcan_f pcan_l140(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;
pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53"
"\x65\x74\x43\x41\x4e\x53\x69\x6c\x65\x6e\x74\x4f\x66\x66\x28\x29\n",
pcan_o);pcan_q pcan_l36(pcan_b,3,3,0,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_f pcan_l202(pcan_n pcan_p*pcan_b,pcan_l43*pcan_l73){pcan_f pcan_g
;pcan_c pcan_a=0;pcan_c pcan_l31=0;pcan_c pcan_l39=0;pcan_s(pcan_v""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x42\x54"
"\x52\x30\x42\x54\x52\x31\x28\x29\n",pcan_o);pcan_g=pcan_l55(pcan_b,1
,1,&pcan_l31,&pcan_l39,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&
pcan_a); *pcan_l73=pcan_l39; *pcan_l73<<=8; *pcan_l73|=pcan_l31;
pcan_s(pcan_v"\x25\x73\x3a\x20\x42\x54\x52\x30\x42\x54\x52\x31\x20"
"\x3d\x20\x30\x78\x25\x30\x34\x78\n",pcan_o, *pcan_l73);pcan_q pcan_g
;}pcan_f pcan_l199(pcan_n pcan_p*pcan_b,pcan_l44*pcan_l87){pcan_f
pcan_g=0;pcan_c pcan_a=0;pcan_c pcan_l31=0;pcan_s(pcan_v"\x25\x73\x3a"
"\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x51\x75\x61\x72\x74"
"\x7a\x28\x29\n",pcan_o);pcan_g=pcan_l55(pcan_b,2,1,&pcan_l31,&pcan_a
,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a,&pcan_a); *pcan_l87=pcan_l31
; *pcan_l87*=1000000L;pcan_s(pcan_v"\x25\x73\x3a\x20\x46\x72\x65\x71"
"\x75\x65\x6e\x7a\x20\x3d\x20\x25\x75\n",pcan_o, *pcan_l87);pcan_q
pcan_g;}pcan_f pcan_l191(pcan_n pcan_p*pcan_b,pcan_c pcan_l53,pcan_c
pcan_l28){pcan_f pcan_g=0;pcan_c pcan_a[8];pcan_f pcan_x;pcan_s(
pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74"
"\x41\x6e\x79\x74\x68\x69\x6e\x67\x28\x29\n",pcan_o);pcan_l124(pcan_x
=0;pcan_x<7;pcan_x++)pcan_a[pcan_x]=0;pcan_g=pcan_l55(pcan_b,pcan_l53
,pcan_l28,&pcan_a[0],&pcan_a[1],&pcan_a[2],&pcan_a[3],&pcan_a[4],&
pcan_a[5],&pcan_a[6],&pcan_a[7]);pcan_s(pcan_v"\x25\x73\x3a\x20\x46"
"\x75\x6e\x2f\x4e\x75\x6d\x3a\x25\x64\x2f\x25\x64\x20\x20\x30\x78\x25"
"\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78"
"\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78"
"\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32\x78\x20\x30\x78\x25\x30\x32"
"\x78\n",pcan_o,pcan_l53,pcan_l28,pcan_a[0],pcan_a[1],pcan_a[2],
pcan_a[3],pcan_a[4],pcan_a[5],pcan_a[6],pcan_a[7]);pcan_q pcan_g;}
pcan_f pcan_l185(pcan_n pcan_p*pcan_b,pcan_c*pcan_l107){pcan_f pcan_g
;pcan_c pcan_a=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f"
"\x68\x77\x5f\x67\x65\x74\x44\x65\x76\x69\x63\x65\x4e\x72\x28\x29\n",
pcan_o);pcan_g=pcan_l55(pcan_b,4,1,pcan_l107,&pcan_a,&pcan_a,&pcan_a,
&pcan_a,&pcan_a,&pcan_a,&pcan_a);pcan_s(pcan_v"\x25\x73\x3a\x20\x44"
"\x65\x76\x69\x63\x65\x4e\x72\x20\x3d\x20\x30\x78\x25\x30\x32\x78\n",
pcan_o, *pcan_l107);pcan_q pcan_g;}pcan_f pcan_l183(pcan_n pcan_p*
pcan_b){pcan_c pcan_a=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61"
"\x6e\x5f\x68\x77\x5f\x53\x65\x74\x45\x78\x74\x56\x43\x43\x4f\x6e\x28"
"\x29\n",pcan_o);pcan_q pcan_l36(pcan_b,0xA,2,1,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a
);}pcan_f pcan_l172(pcan_n pcan_p*pcan_b,pcan_c pcan_l158){pcan_c
pcan_a=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77"
"\x5f\x53\x65\x74\x44\x65\x76\x69\x63\x65\x4e\x72\x28\x29\n",pcan_o);
pcan_q pcan_l36(pcan_b,4,2,pcan_l158,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}
pcan_f pcan_l196(pcan_n pcan_p*pcan_b,pcan_l44 pcan_l68){pcan_c pcan_a
=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53"
"\x65\x74\x53\x4e\x52\x28\x29\n",pcan_o);pcan_q pcan_l36(pcan_b,6,2,(
pcan_c)(pcan_l68&0xff),(pcan_c)((pcan_l68>>8)&0xff),(pcan_c)((
pcan_l68>>16)&0xff),(pcan_c)((pcan_l68>>24)&0xff),pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}pcan_l29
pcan_f pcan_l147(pcan_n pcan_p*pcan_b){pcan_c pcan_a=0;pcan_s(pcan_v""
"\x25\x73\x3a\x20\x70\x63\x61\x6e\x5f\x68\x77\x5f\x53\x65\x74\x45\x78"
"\x74\x56\x43\x43\x4f\x66\x66\x28\x29\n",pcan_o);pcan_q pcan_l36(
pcan_b,0xA,2,0,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,
pcan_a,pcan_a,pcan_a,pcan_a,pcan_a,pcan_a);}pcan_f pcan_hw_getSNR(
pcan_n pcan_p*pcan_b,pcan_l44*pcan_l70){pcan_f pcan_g;pcan_f pcan_x;
pcan_c pcan_l52[4];pcan_c pcan_a;pcan_s(pcan_v"\x25\x73\x3a\x20\x70"
"\x63\x61\x6e\x5f\x68\x77\x5f\x67\x65\x74\x53\x4e\x52\x28\x29\n",
pcan_o);pcan_g=pcan_l55(pcan_b,6,1,&pcan_l52[0],&pcan_l52[1],&
pcan_l52[2],&pcan_l52[3],&pcan_a,&pcan_a,&pcan_a,&pcan_a); *pcan_l70=
0;pcan_l124(pcan_x=3;pcan_x>=0;pcan_x--){ *pcan_l70<<=8; *pcan_l70|=
pcan_l52[pcan_x];}pcan_s(pcan_v"\x25\x73\x3a\x20\x53\x4e\x52\x20\x3d"
"\x20\x30\x78\x25\x30\x38\x78\n",pcan_o, *pcan_l70);pcan_q pcan_g;}
pcan_f pcan_hw_Init(pcan_n pcan_p*pcan_b,pcan_l43 pcan_l154,pcan_c
pcan_l132){pcan_f pcan_g=0;pcan_s(pcan_v"\x25\x73\x3a\x20\x70\x63\x61"
"\x6e\x5f\x68\x77\x5f\x49\x6e\x69\x74\x28\x29\n",pcan_o);pcan_g=
pcan_l148(pcan_b,pcan_l154);pcan_e(pcan_g)pcan_l35 pcan_l26;pcan_e(
pcan_b->pcan_m.pcan_l.pcan_l113>3){pcan_e(pcan_l132)pcan_g=pcan_l160(
pcan_b);pcan_z pcan_g=pcan_l140(pcan_b);pcan_e(pcan_g)pcan_l35
pcan_l26;}pcan_z{pcan_e(pcan_l132){pcan_g=-pcan_l177;pcan_l35 pcan_l26
;}}pcan_g=pcan_l147(pcan_b);pcan_l141(pcan_b);pcan_l26:pcan_q pcan_g;
}pcan_f pcan_hw_DecodeMessage(pcan_n pcan_p*pcan_b,pcan_c*pcan_d,
pcan_f pcan_l74){pcan_f pcan_g=0;pcan_f pcan_x,pcan_l32;pcan_c
pcan_l157;pcan_c pcan_l112;pcan_c pcan_l37=0;pcan_c pcan_y;pcan_l143*
pcan_t;pcan_l153 pcan_r;pcan_c*pcan_l82=pcan_d;pcan_f pcan_l117=0;
pcan_c*pcan_l119=pcan_d;pcan_c pcan_l122=0;pcan_e(!pcan_l74)pcan_q
pcan_g;pcan_l157= *pcan_d++;pcan_l112= *pcan_d++;pcan_l124(pcan_x=0;(
pcan_x<pcan_l112);pcan_x++){pcan_l116 pcan_k;pcan_l37= *pcan_d++;
pcan_e(!(pcan_l37&0x40)){pcan_f pcan_l42;pcan_g=pcan_l173(&pcan_b->
pcan_l115,(pcan_l48* )&pcan_t);pcan_e(pcan_g)pcan_l35 pcan_l26;pcan_y
=pcan_l37&0x0F;pcan_e(pcan_y>8)pcan_y=8;pcan_t->pcan_l33.pcan_l129=
pcan_y;pcan_l42=pcan_l37&0x10;pcan_e(pcan_l42)pcan_t->pcan_l33.
pcan_l54=pcan_l159;pcan_z pcan_t->pcan_l33.pcan_l54=pcan_l174;pcan_e(
pcan_l37&0x20){pcan_t->pcan_l33.pcan_l54|=pcan_l161;
#ifdef __LITTLE_ENDIAN
pcan_k.pcan_i[0]= *pcan_d++;pcan_k.pcan_i[1]= *pcan_d++;pcan_k.pcan_i
[2]= *pcan_d++;pcan_k.pcan_i[3]= *pcan_d++;
#else
pcan_k.pcan_i[3]= *pcan_d++;pcan_k.pcan_i[2]= *pcan_d++;pcan_k.pcan_i
[1]= *pcan_d++;pcan_k.pcan_i[0]= *pcan_d++;
#endif
pcan_k.pcan_l41>>=3;}pcan_z{pcan_k.pcan_l41=0;
#ifdef __LITTLE_ENDIAN
pcan_k.pcan_i[0]= *pcan_d++;pcan_k.pcan_i[1]= *pcan_d++;
#else
pcan_k.pcan_i[3]= *pcan_d++;pcan_k.pcan_i[2]= *pcan_d++;
#endif
pcan_k.pcan_l41>>=5;}pcan_t->pcan_l33.pcan_l152=pcan_k.pcan_l41;
pcan_e(!pcan_l122){
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_i[0]= *pcan_d++;pcan_r.pcan_i[1]= *pcan_d++;
#else
pcan_r.pcan_i[1]= *pcan_d++;pcan_r.pcan_i[0]= *pcan_d++;
#endif
pcan_l83(pcan_b,pcan_r.pcan_l95,pcan_x);}pcan_z pcan_l104(pcan_b, *
pcan_d++);pcan_t->pcan_l164=pcan_l126(pcan_b);pcan_l32=0;pcan_e(
pcan_l42){pcan_l38(pcan_y--)pcan_t->pcan_l33.pcan_l65[pcan_l32++]=0;}
pcan_z{pcan_l38(pcan_y--)pcan_t->pcan_l33.pcan_l65[pcan_l32++]= *
pcan_d++;}pcan_e((!pcan_b->pcan_l186)&&(pcan_l37&0x20)){pcan_g=
pcan_l203(&pcan_b->pcan_l115);pcan_e(pcan_g)pcan_l35 pcan_l26;}pcan_z
{pcan_g=pcan_l180(&pcan_b->pcan_l115);pcan_e(pcan_g)pcan_l35 pcan_l26
;pcan_l117++;}pcan_l122++;}pcan_z{pcan_l143 pcan_l145;pcan_c pcan_l53
;pcan_c pcan_l28;pcan_c pcan_a;pcan_t=&pcan_l145;pcan_t->pcan_l33.
pcan_l54=pcan_l181;pcan_y=pcan_l37&0x0F;pcan_e(pcan_y>8)pcan_y=8;
pcan_t->pcan_l33.pcan_l129=pcan_y;pcan_l53= *pcan_d++;pcan_l28= *
pcan_d++;pcan_e(pcan_l37&0x80){pcan_e(!pcan_x){
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_i[0]= *pcan_d++;pcan_r.pcan_i[1]= *pcan_d++;
#else
pcan_r.pcan_i[1]= *pcan_d++;pcan_r.pcan_i[0]= *pcan_d++;
#endif
pcan_l83(pcan_b,pcan_r.pcan_l95,pcan_x);}pcan_z pcan_l104(pcan_b, *
pcan_d++);}pcan_l176(pcan_l53){pcan_l51 1:pcan_e((pcan_l28&0x02)||(
pcan_l28&0x40)){pcan_b->pcan_l61|=pcan_l190;pcan_b->pcan_l86++;}
pcan_e(pcan_l28&0x10){pcan_b->pcan_l61|=pcan_l189;pcan_b->pcan_l86++;
}pcan_e(pcan_l28&0x08){pcan_b->pcan_l61|=pcan_l205;pcan_b->pcan_l86++
;}pcan_e(pcan_l28&0x04)pcan_b->pcan_l61|=pcan_l201;pcan_l32=0;
pcan_l38(pcan_y--)pcan_t->pcan_l33.pcan_l65[pcan_l32++]= *pcan_d++;
pcan_l57;pcan_l51 2:pcan_a= *pcan_d++;pcan_a= *pcan_d++;pcan_l57;
pcan_l51 3:pcan_a= *pcan_d++;pcan_l57;pcan_l51 4:
#ifdef __LITTLE_ENDIAN
pcan_r.pcan_i[0]= *pcan_d++;pcan_r.pcan_i[1]= *pcan_d++;
#else
pcan_r.pcan_i[1]= *pcan_d++;pcan_r.pcan_i[0]= *pcan_d++;
#endif
pcan_l83(pcan_b,pcan_r.pcan_l95,pcan_x);pcan_l57;pcan_l51 5:pcan_e(
pcan_l28&0x80){pcan_b->pcan_l61|=pcan_l192;pcan_b->pcan_l86++;}
pcan_l32=0;pcan_l38(pcan_y--)pcan_t->pcan_l33.pcan_l65[pcan_l32++]= *
pcan_d++;pcan_l57;pcan_l51 10:pcan_l57;pcan_l182:pcan_l98(pcan_l59""
"\x25\x73\x3a\x20\x75\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x66\x75"
"\x6e\x63\x74\x69\x6f\x6e\x2c\x20\x69\x20\x3d\x20\x25\x64\x2c\x20\x75"
"\x63\x53\x74\x61\x74\x75\x73\x4c\x65\x6e\x20\x3d\x20\x30\x78\x25\x30"
"\x32\x78\n",pcan_o,pcan_x,pcan_l37);pcan_l149(pcan_l119,4);}pcan_t->
pcan_l164=pcan_l126(pcan_b);}pcan_e((pcan_d-pcan_l82)>pcan_l74){
pcan_e((pcan_b->pcan_m.pcan_l.pcan_l113>3)||((pcan_b->pcan_m.pcan_l.
pcan_l113<=3)&&((pcan_d-pcan_l82)>(pcan_l74+1)))){pcan_g=-pcan_l200;
pcan_l98(pcan_l59"\x25\x73\x3a\x20\x49\x6e\x74\x65\x72\x6e\x61\x6c"
"\x20\x45\x72\x72\x6f\x72\x20\x3d\x20\x25\x64\x20\x28\x25\x64\x2c\x20"
"\x25\x64\x29\n",pcan_o,pcan_g,(pcan_d-pcan_l82),pcan_l74);pcan_l149(
pcan_l119,4);pcan_l35 pcan_l26;}}}pcan_e(pcan_l117)pcan_l184(&pcan_b
->pcan_l179);pcan_l26:pcan_q pcan_g;}pcan_f pcan_hw_EncodeMessage(
pcan_n pcan_p*pcan_b,pcan_c*pcan_d,pcan_f*pcan_l64){pcan_f pcan_g=0;
pcan_f pcan_l121=0;pcan_c*pcan_w=pcan_d;pcan_c pcan_y;pcan_l116 pcan_k
;pcan_c*pcan_l72;pcan_c*pcan_l85;pcan_l178*pcan_t;pcan_f pcan_l32;
pcan_c pcan_l96=0;pcan_f pcan_l93= *pcan_l64;pcan_f pcan_l142=
pcan_l93-14; *pcan_l64=0; *pcan_w++=2;pcan_l85=pcan_w++;pcan_l38(!
pcan_l96&&((pcan_w-pcan_d)<pcan_l142)){pcan_e((pcan_g=pcan_l195(&
pcan_b->pcan_l133,(pcan_l48* )&pcan_t))){pcan_l96=1;pcan_e(pcan_g!=-
pcan_l198){pcan_s(pcan_v"\x25\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20"
"\x63\x6c\x61\x69\x6d\x20\x77\x72\x69\x74\x65\x46\x69\x66\x6f\x2c\x20"
"\x61\x76\x61\x69\x6c\x20\x64\x61\x74\x61\x20\x3d\x20\x25\x64\x2c\x20"
"\x65\x72\x72\x20\x3d\x20\x25\x64\n",pcan_o,pcan_b->pcan_l133.
pcan_l187,pcan_g);}}pcan_z{pcan_f pcan_l42;pcan_l72=pcan_w++; *
pcan_l72=pcan_y=pcan_t->pcan_l129&0x0F;pcan_l42=pcan_t->pcan_l54&
pcan_l159;pcan_e(pcan_l42) *pcan_l72|=0x10;pcan_l32=0;pcan_k.pcan_l41
=pcan_t->pcan_l152;pcan_e(pcan_t->pcan_l54&pcan_l161){ *pcan_l72|=
0x20;pcan_k.pcan_l41<<=3;
#ifdef __LITTLE_ENDIAN
 *pcan_w++=pcan_k.pcan_i[0]; *pcan_w++=pcan_k.pcan_i[1]; *pcan_w++=
pcan_k.pcan_i[2]; *pcan_w++=pcan_k.pcan_i[3];
#else
 *pcan_w++=pcan_k.pcan_i[3]; *pcan_w++=pcan_k.pcan_i[2]; *pcan_w++=
pcan_k.pcan_i[1]; *pcan_w++=pcan_k.pcan_i[0];
#endif
}pcan_z{pcan_k.pcan_l41<<=5;
#ifdef __LITTLE_ENDIAN
 *pcan_w++=pcan_k.pcan_i[0]; *pcan_w++=pcan_k.pcan_i[1];
#else
 *pcan_w++=pcan_k.pcan_i[1]; *pcan_w++=pcan_k.pcan_i[0];
#endif
}pcan_e(!pcan_l42){pcan_l32=0;pcan_l38(pcan_y--) *pcan_w++=pcan_t->
pcan_l65[pcan_l32++];}pcan_l121++;pcan_e((pcan_g=pcan_l194(&pcan_b->
pcan_l133)))pcan_l96=1;}}pcan_e((pcan_w-pcan_d)>2){ *pcan_l64=
pcan_l93;pcan_w=pcan_d+pcan_l93-1; *pcan_w=(pcan_c)(pcan_b->pcan_m.
pcan_l.pcan_l204++&0xff); *pcan_l85=pcan_l121;}pcan_z{ *pcan_l64=0; *
pcan_l85=0;}pcan_q pcan_g;}
